<?php
	class iredactor extends cmsFrontend {
		
		protected $useOptions = true;
		
		public function actionUpload(){
			
			if (!$this->cms_user->is_logged) {
				return $this->cms_template->renderJSON(array(
                'status' => 'error',
                'msg'    => 'auth error'
				));
			}
			
			$file_context = array(
            'target_controller' => $this->request->get('target_controller', ''),
            'target_subject' => $this->request->get('target_subject', ''),
            'target_id' => $this->request->get('target_id', '')
			);
			
			$result = cmsCore::getController('images')->
			registerUploadFile($file_context)->
			uploadWithPreset('file', 'wysiwyg_iredactor');
			
			if (!$result['success']){
				
				return $this->cms_template->renderJSON(array(
                'status' => 'error',
                'msg'    => $result['error']
				));
				
			}
			
			return $this->cms_template->renderJSON(array(
            'status'   => 'success',
            'filelink' => $result['image']['url']
			));
			
		}
		
		public function actionUploadFile(){
		
		$options = $this->options;
			
			if (!$this->cms_user->is_logged) {
				return $this->cms_template->renderJSON(array(
                'status' => 'error',
                'msg'    => 'auth error'
				));
			}
			
			$file_context = array(
            'target_controller' => $this->request->get('target_controller', ''),
            'target_subject' => $this->request->get('target_subject', ''),
            'target_id' => $this->request->get('target_id', '')
			);
			
			$result = $this->cms_uploader->uploadForm('file', $options['extensions'], files_convert_bytes($options['maxsize'].'m'), $destination = false);
			
			if ($result['success'] === false){
				
				return $this->cms_template->renderJSON(array(
                'status' => 'error',
                'msg'    => $result['error']
				));
				
			}
			
			$filename = $options['options']['filesize'] ? $result['name'].' '. files_format_bytes($result['size']) : $result['name'];
			
			
			return $this->cms_template->renderJSON(array(
            'status'   => 'success',
            'filelink' => '/upload/'.$result['url'],
			'filename' => $filename ,
			'msg'    => $result['success']
			));
			
		}
	}						